// shell.c
/*
UC: 21178 - Laboratorio de Programacao
Ano 2019/20 - EFOLIO B - Mundo dos rectangulos - UAb
18/05/2020
- Marcio Santos n.º 1502471
*/
#include<stdio.h>
#include<stdlib.h>
#include<stdarg.h>
#include<string.h>
#include<termios.h>
#include<unistd.h>
#include<fcntl.h>
#include<sys/ioctl.h>
#include "interface.h"
#include "shell.h"


const char *txt_comandos[] = {
  "help", // para impressao na nav
  "exit",
  "create",
  "moveright",
  "moveleft",
  "rotate",
  "info",
  "colide",
  "gravidade",
  "load",
};

const char *txt_erro[] = {
  "Ouch, close but no cigar! Better try again.",
  "#%&#!%?#&!, mumble rumble",
  "Comando não encontrado. Reveja se foi bem digitado. help tem mais opções.",
  "Houve um erro catastrófico com o comando digitado.",
  "Wrong cheese. Please choose a better one.",
  "Command not found.",
  "Choose something else to type.",
  "Where did you learn to type?",
  "Please check your eye-glasses first.",
  "stty: monkey type mode detected.",
  "Do that again and see what happens...",
  "Bailing out, you are on your own now. Good luck.",
  "404'd - File not found.",
  "mundo is unable to locate a suitable version for the command you typed."
};

const char *txt_help =  "COMANDOS DISPONIVEIS:\n"
"help - mostra esta mensagem\n" \
"exit - termina a aplicação\n" \
"create xx,xx+xx,xx - adiciona um rectangulo\n" \
"moveright xx,xx+xx - move para a direita\n" \
"moveleft xx,xx+xx - move para a esquerda\n" \
"rotate - roda o mundo 90º para a direita\n" \
"load - carrega dados exemplo";

int _help(){
  fprintf(stdout, "%s", txt_help);
  return 0;
}

void _shell(){
  int tam_buffer=0;
  int tam_cmd=0;
  int tam_txt_comandos = TAM_ARRAY(txt_comandos);
  unsigned tam_txt_erro = TAM_ARRAY(txt_erro);
  int (*opcoes[tam_txt_comandos])();
  char* cmd;

  opcoes[0] = _help;
  opcoes[1] = sair_i;
  opcoes[2] = _create;
  opcoes[3] = _moveright;
  opcoes[4] = _moveleft;
  opcoes[5] = _rotate;
  opcoes[6] = _info_rect;
  opcoes[7] = _colide;
  opcoes[8] = _gravidade;
  opcoes[9] = _load;

  fprintf(stdout,"\nDigite help para mais opções\n" );
  fprintf(stdout, ">");
  fgets(g.buffer,MAXSTR,stdin);
  tam_buffer = strlen(g.buffer);
  if (tam_buffer > 2){
    g.buffer[tam_buffer-1]=0;
    cmd = strtok(g.buffer," ");
    tam_cmd = strlen(cmd);
    if(tam_buffer - tam_cmd > 2){
        strcpy(g.param, strtok(0, "\n"));
    }
    if (tam_cmd > 1){
      for(int i=0;i < tam_txt_comandos;i++){
        if(!strcmp(cmd, txt_comandos[i])){
          opcoes[i]();
          break;
        }
        if(i == tam_txt_comandos-1){
          fprintf(stdout, "%s\n",txt_erro[random_number(tam_txt_erro)]);
        }
      }
    }
  }
}

int _load(){
  carregar_ficheiro();
  gravidade();
  print_all();
  return 0;
}

int _rotate(){
  short colisao=0;
  unsigned tam_txt_erro = TAM_ARRAY(txt_erro);
  rectangulo** tmp=0;
  order_rect_desc();
  tmp = g._r;
  g._r = g._u;
  g._u = tmp;
  g._tam_rarray = g._tam_uarray;
  g._tam_uarray = 0;
  if(g.rotacao){
    g.rotacao = 0;
  } else {
    g.rotacao = 1;
  }
  for (size_t i = 0; i < g._tam_rarray; i++) {
    rot_rect(g._r[i]);
    if(create(g._r[i]->_x, g._r[i]->_y, g._r[i]->_c, g._r[i]->_a )){
      fprintf(stdout, "%s\n",txt_erro[random_number(tam_txt_erro)]);
      colisao = 1;
    }
    gravidade();
  }
  if(colisao){
    tmp = g._r;
    g._r = g._u;
    g._u = tmp;
    g._tam_uarray = g._tam_rarray;
    g._tam_rarray = 0;
    if(g.rotacao){
      g.rotacao = 0;
    } else {
      g.rotacao = 1;
    }
  } else {
    for (size_t i = 0; i < g._tam_rarray; i++) {
      free(g._r[i]);
      g._tam_rarray--;
    }
  }
  gravidade();
  print_all();
  return 0;
}

int _gravidade(){
  gravidade();
  return 0;
}

int _colide(){
  unsigned tam_txt_erro = TAM_ARRAY(txt_erro);
  if (get_param(2)){
    fprintf(stdout, "%s\n",txt_erro[random_number(tam_txt_erro)]);
    return 1;
  }
  if(rect_intersect(g._u[g._param1],g._u[g._param2]) ){
    fprintf(stderr, "A colide com B\n");
  } else {
    fprintf(stderr, "A não colide com B\n");
  }
  return 0;
}

int _info_rect(){
  unsigned tam_txt_erro = TAM_ARRAY(txt_erro);
  if (get_param(1)){
    fprintf(stdout, "%s\n",txt_erro[random_number(tam_txt_erro)]);
    return 1;
  }
  if(info_rect(g._param1)){
    fprintf(stdout, "%s\n",txt_erro[random_number(tam_txt_erro)]);
    return 1;
  }
  return 0;
}

int _create(){
  unsigned tam_txt_erro = TAM_ARRAY(txt_erro);
  if (get_param(4)){
    fprintf(stdout, "%s\n",txt_erro[random_number(tam_txt_erro)]);
    return 1;
  }
  if(create(g._param1, g._param2, g._param3, g._param4 )){
    fprintf(stdout, "%s\n",txt_erro[random_number(tam_txt_erro)]);
    return 1;
  }
  gravidade();
  print_all();
  return 0;
}

int _moveright(){
  int pos=-1;
  unsigned tam_txt_erro = TAM_ARRAY(txt_erro);
  if (get_param(3)){
    fprintf(stdout, "%s\n",txt_erro[random_number(tam_txt_erro)]);
  }
  pos = find_pos_rect(g._param1, g._param2);
  if( pos > -1){
    g._u[pos]->_x += g._param3;
    if ( (limitex(g._u[pos]->_x, g._u[pos]->_x+g._u[pos]->_c-1)) || (colisao(g._u[pos])) ){
      fprintf(stdout, "Colisao. Não é possível realizar o movimento.\n");
      g._u[pos]->_x -= g._param3;
      return 1;
    }
    gravidade();
    print_all();
  } else {
    fprintf(stdout, "Não existe rectangulo com essa pos\n");
    return 1;
  }
  return 0;
}

int _moveleft(){
  int pos=-1;
  unsigned tam_txt_erro = TAM_ARRAY(txt_erro);
  if (get_param(3)){
    fprintf(stdout, "%s\n",txt_erro[random_number(tam_txt_erro)]);
  }
  pos = find_pos_rect(g._param1, g._param2);
  if( pos > -1){
    g._u[pos]->_x -= g._param3;
    if ( (limitex(g._u[pos]->_x, g._u[pos]->_x+g._u[pos]->_c-1)) || (colisao(g._u[pos])) ){
      fprintf(stdout, "Colisao. Não é possível realizar o movimento.\n");
      g._u[pos]->_x += g._param3;
      return 1;
    }
    gravidade();
    print_all();
  } else {
    fprintf(stdout, "Não existe rectangulo com essa pos\n");
    return 1;
  }
  return 0;
}

int get_param(int nr_params){
  int tam = 0;
  int delim = 0;
  if(nr_params == 1){
    if (!(sscanf (g.param,"%hu",&g._param1) == 1) ){
      fprintf(stdout, "Erro: É esperado 1 parametro no formato xx\n" );
      return 1; // erro
    }
  }
  if (strlen(g.param) > 2){
    tam = strlen(g.param);
    for(int i=0; i < tam; i++){
      if (g.param[i] == ',' || g.param[i] == '+' ){
        delim++;
      }
    }
    if(nr_params == 2){
      if(delim == 1){
        if (!(sscanf (g.param,"%hu,%hu",&g._param1, &g._param2) == 2) ){
          fprintf(stdout, "Erro: Sao esperados 2 parametros no formato xx,xx\n" );
          return 1; // erro
        }
      } else {
        fprintf(stdout, "Erro: Sao esperados 2 parametros no formato xx,xx\n" );
        return 1; // erro
      }
    }
    if(nr_params == 3){
      if(delim == 2){
        if (!(sscanf (g.param,"%hu,%hu+%hu",&g._param1, &g._param2, &g._param3) == 3) ){
          fprintf(stdout, "Erro: Sao esperados 3 parametros no formato xx,xx+xx\n" );
          return 1; // erro
        }
      } else {
        fprintf(stdout, "Erro: Sao esperados 3 parametros no formato xx,xx+xx\n" );
        return 1; // erro
      }
    }
    if(nr_params == 4){
      if(delim == 3){
        if (!(sscanf (g.param,"%hu,%hu+%hu,%hu",&g._param1, &g._param2, &g._param3, &g._param4) == 4) ){
          fprintf(stdout, "Erro: Sao esperados 4 parametros no formato xx,xx+xx,xx\n" );
          return 1; // erro
        }
      } else {
        fprintf(stdout, "Erro: Sao esperados 4 parametros no formato xx,xx+xx,xx\n" );
        return 1; // erro
      }
    }
  }
  return 0; // ok
  }
